/**
 * Copyright (c) 2000,2001 Yasuhiro ABE <yasu@dengaku.org>. 
 * All rights reserved. 
 * See the file COPYING for license details. 
 *
 * If you have any comments, please send e-mail to yasu@dengaku.org. 
 **/

#include"rnids.h"

#ifndef NOT_PACKETOBJ
#define NOT_PACKETOBJ 1
#endif

VALUE cNIDSPacket;

#ifndef NOT_PACKETOBJ

struct packet_object {
  /* from tcppkt.c */
  struct tcp_stream *a_tcp;
  struct half_stream *hlf;
  int op_side;
  /* from ippkt.c */
  struct ip *iph;
  /* from udppkt.c */
  struct tuple4 *addr; /* <== &(a_tcp->addr) */
  char *buf;
  int len;
  //struct ip *iph;
};

#define GetTUPLE(obj, tuple) \
    Data_Get_Struct(obj, struct tuple4, tuple)

#define PACKET_METHOD(func, val) \
static VALUE\
(func)(self)\
     VALUE self;\
{\
    struct tuple4 *tuple;\
\
    GetTUPLE(self, tuple);\
    return (val);\
}

PACKET_METHOD(packet_daddr, tuple->daddr)
PACKET_METHOD(packet_saddr, tuple->saddr)
PACKET_METHOD(packet_sport, tuple->source)
PACKET_METHOD(packet_dport, tuple->dest)

void
Init_packet() {
  cNIDSPacket = rb_define_class("NIDS_Packet", rb_cObject);

  rb_define_method(cNIDSPacket, "daddr", packet_daddr, 0);
  rb_define_method(cNIDSPacket, "saddr", packet_saddr, 0);
  rb_define_method(cNIDSPacket, "dport", packet_dport, 0);
  rb_define_method(cNIDSPacket, "sport", packet_sport, 0);
}
#else
void
Init_packet() {
  cNIDSPacket = rb_define_class("NIDS_Packet", rb_cObject);
}
#endif
