#!/usr/local/bin/ruby

#
# Copyright (c) 2000,2001 Yasuhiro ABE <yasu@dengaku.org>
#

require "rnids"

class SEED < NIDS
  def callback(pkt)
    return if not pkt.kind_of?(NIDS_TCP)

    case pkt.tcp_state
    when NIDS::NIDS_JUST_EST
      print "connection establised : "
      print "#{pkt.saddr}:#{pkt.sport} -> #{pkt.daddr}:#{pkt.dport}\n"
    when NIDS::NIDS_DATA
      print "sending data : "
      print "#{pkt.saddr}:#{pkt.sport} -> #{pkt.daddr}:#{pkt.dport}\n"
    when NIDS::NIDS_CLOSE
      print "connection closed : "
      print "#{pkt.saddr}:#{pkt.sport} -> #{pkt.daddr}:#{pkt.dport}\n"
    when NIDS::NIDS_RESET
      print "connection reseted : "
      print "#{pkt.saddr}:#{pkt.sport} -> #{pkt.daddr}:#{pkt.dport}\n"
    when NIDS::NIDS_TIMED_OUT
      print "connection timedout : "
      print "#{pkt.saddr}:#{pkt.sport} -> #{pkt.daddr}:#{pkt.dport}\n"
    else
      raise "you don't allow reach here"
    end
  end

  def kill(pkt)
    if pkt.tcp_data =~ /phf/
      return true
    end

    return false
  end
end

#
# MAIN proc
#

seed = SEED.new
seed.run
