#!/usr/bin/ruby

require "rnids"

n = NIDS.new

n.use_tcp(true)
n.use_udp(true)
n.use_ip(false)

def n.callback(packet)
  if packet.kind_of?(NIDS_TCP)
    if packet.tcp_state == NIDS::NIDS_CLOSE
      print "connection closed\n"
    elsif packet.tcp_state == NIDS::NIDS_RESET
      print "connection reset\n"
    elsif packet.tcp_state == NIDS::NIDS_TIMED_OUT
      print "connection timed out\n"
    else
      printf "tcp: %s:%d -> %s:%d\n", packet.saddr, packet.sport, 
	packet.daddr, packet.dport
      printf "tcp: %s\n", packet.data[0,3000].to_s.dump
    end
  elsif packet.kind_of?(NIDS_UDP)
    printf "udp: %s:%d -> %s:%d\n", packet.saddr, packet.sport, 
      packet.daddr, packet.dport
    printf "udp: %s\n", packet.data[0,3000].to_s.dump
  end
end

trap("SIGINT", "EXIT")

NIDSupport::promisc(false)
n.run
