/**
 * Copyright (c) 2000 Yasuhiro ABE <yasu@dengaku.org>. All rights reserved.
 * See the file COPYING for license details.
 *
 * If you have any comments, please send e-mail to yasu@dengaku.org.
 **/

/* common files */
#include "ruby.h"
#include "rubysig.h"

#include <sys/time.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <string.h>
#include <stdio.h>
#include "nids.h"

/* nids.c */
extern VALUE eNidsError;
#define int_ntoa(x)     inet_ntoa(*((struct in_addr *)&x))

/* ippkt.c */
extern void Init_ippkt(void);
extern VALUE rnids_ippkt_new(struct ip *iph);

/* tcppkt.c */ 
extern void Init_tcppkt(void);
extern VALUE rnids_tcppkt_new(struct tcp_stream *a_tcp, 
			      struct half_stream *hlf);
extern VALUE rnids_tcppkt_new2(struct tcp_stream *a_tcp,
			      struct half_stream *hlf,
			      int op_side);

/* udppkt.c */
extern void Init_udppkt(void);
extern VALUE rnids_udppkt_new(struct tuple4 *addr,
			      char *buf,
			      int len,
			      struct ip *iph);

/* packet.c */
/* extern void Init_packet(void); */
/* extern VALUE cNIDSPacket; */


/* support.c */
extern void Init_support(void);
